import { AgentConfig } from "../config";
import { AgentType, IAgentEvent, IAgentStartInfo, IPingData, Technology } from "./agent-events-conracts";
import { SlJsInfra } from "../../index";
import { Watchdog } from "../watchdog";
import bunyan = require('bunyan');
export declare class AgentEventsController {
    private static readonly PING_INTERVAL;
    private static readonly MAX_SHUTDOWN_RETRIES;
    private agentConfig;
    private type;
    private agentId;
    private backendProxy;
    private logger;
    private technology;
    private sendsPing;
    private _watchdog;
    private startRequestStatus;
    private shutDownRetries;
    constructor(agentConfig: AgentConfig, agentType: AgentType, technology: Technology, sendsPing: boolean, logger: bunyan, backendProxy?: SlJsInfra.BackendProxy);
    submitAgentStartedEvent(packageJsonFile?: any): Promise<void>;
    private submitAgentEventRequest;
    buildAgentStartEvent(packageJsonFile: any): IAgentEvent<IAgentStartInfo>;
    buildAgentShutdownEvent(): IAgentEvent<IPingData>;
    submitAgentShutdownEvent(): Promise<boolean>;
    submitPingEvent(): void;
    readonly watchdog: Watchdog;
    private resolveTags;
    private resolveTools;
    private createBackendProxy;
    private initWatchdog;
    private buildEvent;
}
